?><?php

/***********************************************
* CONTENIDO MODUL - OUTPUT
*
* Modulname            :     Kommentarmodul, beruht auf comments_sd
* Original Author(s)   :     www.Seamless-Design.de Markus Huebner
* Original Copyright   :     www.Seamless-Design.de Markus Huebner
* Originally Created   :     11.09.2011
* Adapted for 4.9 by   :     www.tone2tone.com, Viktor Lehmann
* modified             :     2013-09-05
* adapted              :     new sorting routine, new comment array, smarty template system, new input possibilities
************************************************/

$db = cRegistry::getDb();
$cfg = cRegistry::getConfig();
$client = cRegistry::getClientId();
$cfgClient = cRegistry::getClientConfig();


// prepare pre-configured values
$selected_depth = "CMS_VALUE[17]";
$selectDepth    = "CMS_VAR[17]";
$selected_tpl = "CMS_VALUE[100]";
$selectTpl    = "CMS_VAR[100]";
if ( "CMS_VALUE[10]" == "false" ) $active_false = "checked"; else $active_true = "checked"; 
if ( "CMS_VALUE[12]" == "false" ) $br_output_false = "checked"; else $br_output_true = "checked"; 
if ( "CMS_VALUE[13]" == "false" ) $bind_idart_false = "checked"; else $bind_idart_true = "checked"; 
if ( "CMS_VALUE[18]" == "false" ) $language_all_false = "checked"; else $language_all_true = "checked"; 
if ( "CMS_VALUE[16]" == "0" ) $immediatepost_false = "checked"; else $immediatepost_true = "checked"; 

// find Smarty-Templates which belong to THIS module by scanning the appropriate subdir
$module = new cModuleHandler($cCurrentModule);
$tplFiles = $module->getAllFilesFromDirectory('template');
array_multisort($tplFiles, SORT_ASC, SORT_STRING);

// construct the HTML
$filltable = array();
$fillrow   = array();
$table = new cHTMLTable();
//first row
$tr = new cHTMLTableRow();
$td = new cHTMLTableData();
$td->setContent(mi18n("label_active"));
$fillrow[] = $td;
$td = new cHTMLTableData();
$input = new cHTMLRadiobutton("CMS_VAR[10]", 'true', '', $active_true);
$input->setLabelText(mi18n("value_active_true"));
$td->setContent($input);
$input2 = new cHTMLRadiobutton("CMS_VAR[10]", 'false', '', $active_false);
$input2->setLabelText(mi18n("value_active_false"));
$td->setContent($input."  ".$input2);
$fillrow[] = $td;
$tr->setContent($fillrow);
$filltable[] = $tr;

//start next row: set amount of entries per page
$fillrow = array();
$tr = new cHTMLTableRow();
$td = new cHTMLTableData();
$td->setContent(mi18n("label_perpage"));
$fillrow[] = $td;
$td = new cHTMLTableData();
$input = new cHTMLTextbox("CMS_VAR[11]", "CMS_VALUE[11]",'10','4','entriesperpage',false,null,'');
$td->setContent($input);
$fillrow[] = $td;
$tr->setContent($fillrow);
$filltable[] = $tr;

//start next row: set amount of countchas
$fillrow = array();
$tr = new cHTMLTableRow();
$td = new cHTMLTableData();
$td->setContent(mi18n("label_countchas"));
$fillrow[] = $td;
$td = new cHTMLTableData();
$input = new cHTMLTextbox("CMS_VAR[14]", "CMS_VALUE[14]",'10','4','amountofcountchas',false,null,'');
$td->setContent($input);
$fillrow[] = $td;
$tr->setContent($fillrow);
$filltable[] = $tr;

//start next row: enable /br output
$fillrow = array();
$tr = new cHTMLTableRow();
$td = new cHTMLTableData();
$td->setContent(mi18n("label_showbr"));
$fillrow[] = $td;
$td = new cHTMLTableData();
$input = new cHTMLRadiobutton("CMS_VAR[12]", 'true', '', $br_output_true);
$input->setLabelText(mi18n("value_br_true"));
$td->setContent($input);
$input2 = new cHTMLRadiobutton("CMS_VAR[12]", 'false', '', $br_output_false);
$input2->setLabelText(mi18n("value_br_false"));
$td->setContent($input."  ".$input2);
$fillrow[] = $td;
$tr->setContent($fillrow);
$filltable[] = $tr;

//start next row: show only entries posted on that page or all?
$fillrow = array();
$tr = new cHTMLTableRow();
$td = new cHTMLTableData();
$td->setContent(mi18n("label_bind_idart"));
$fillrow[] = $td;
$td = new cHTMLTableData();
$input = new cHTMLRadiobutton("CMS_VAR[13]", 'false', '', $bind_idart_false);
$input->setLabelText(mi18n("value_bind_idart_false"));
$td->setContent($input);
$input2 = new cHTMLRadiobutton("CMS_VAR[13]", 'true', '', $bind_idart_true);
$input2->setLabelText(mi18n("value_bind_idart_true"));
$td->setContent($input."  ".$input2);
$fillrow[] = $td;
$tr->setContent($fillrow);
$filltable[] = $tr;

//start next row: show only entries posted in this language or all?
$fillrow = array();
$tr = new cHTMLTableRow();
$td = new cHTMLTableData();
$td->setContent(mi18n("label_language"));
$fillrow[] = $td;
$td = new cHTMLTableData();
$input = new cHTMLRadiobutton("CMS_VAR[18]", 'true', '', $language_all_true);
$input->setLabelText(mi18n("value_language_all_true"));
$td->setContent($input);
$input2 = new cHTMLRadiobutton("CMS_VAR[18]", 'false', '', $language_all_false);
$input2->setLabelText(mi18n("value_language_all_false"));
$td->setContent($input."  ".$input2);
$fillrow[] = $td;
$tr->setContent($fillrow);
$filltable[] = $tr;

//start next row: fill in mail addresses, comma separated. if empty: no mails will be sent
$fillrow = array();
$tr = new cHTMLTableRow();
$td = new cHTMLTableData();
$td->setContent(mi18n("label_mailaddress"));
$fillrow[] = $td;
$td = new cHTMLTableData();
$input = new cHTMLTextbox("CMS_VAR[20]", "CMS_VALUE[20]",'30','100','mailaddress',false,null,'');
$td->setContent($input);
$fillrow[] = $td;
$tr->setContent($fillrow);
$filltable[] = $tr;

//start next row: allow post to be online immediately or set them offline first?
$fillrow = array();
$tr = new cHTMLTableRow();
$td = new cHTMLTableData();
$td->setContent(mi18n("label_immediatepost"));
$fillrow[] = $td;
$td = new cHTMLTableData();
$input = new cHTMLRadiobutton("CMS_VAR[16]", '1', '', $immediatepost_true);
$input->setLabelText(mi18n("value_immediatepost_true"));
$td->setContent($input);
$input2 = new cHTMLRadiobutton("CMS_VAR[16]", '0', '', $immediatepost_false);
$input2->setLabelText(mi18n("value_immediatepost_false"));
$td->setContent($input."  ".$input2);
$fillrow[] = $td;
$tr->setContent($fillrow);
$filltable[] = $tr;

//start next row: amount of sublevels (= answer levels)
$fillrow = array();
$tr = new cHTMLTableRow();
$td = new cHTMLTableData();
$td->setContent(mi18n("label_choose_level"));
$fillrow[] = $td;
$td = new cHTMLTableData();
$selectarray = array( 0, 1, 2, 3, 4, 5, 6);
$select = new cHTMLSelectElement($selectDepth);

$option = new cHTMLOptionElement(mi18n("please_choose"), "");
$select->appendOptionElement($option);
foreach ( $selectarray as $cItem ) {
	//$dirname = $cItem->get('dirname');
	
    $option = new cHTMLOptionElement($cItem, $cItem);
    if ($selected_depth == $cItem) {
        $option->setSelected(true);
    }
    $select->appendOptionElement($option);
}
$td->setContent($select);
$fillrow[] = $td;
$tr->setContent($fillrow);
$filltable[] = $tr;

//start next row with Template info
$fillrow = array();
$tr = new cHTMLTableRow();
$td = new cHTMLTableData();
$td->setContent(mi18n("label_template"));
$fillrow[] = $td;
$td = new cHTMLTableData();
$select = new cHTMLSelectElement($selectTpl);

$option = new cHTMLOptionElement(mi18n("please_choose"), "");
$select->appendOptionElement($option);
foreach ($tplFiles AS $key=>$value) {
	$value = str_replace($tplpath, "", $value);

	$option = new cHTMLOptionElement($value, $value);
    if ($selected_tpl == $value) {
        $option->setSelected(true);
    }
    $select->appendOptionElement($option);
}

$td->setContent($select);
$fillrow[] = $td;
$tr->setContent($fillrow);
$filltable[] = $tr;

// put all rows in the table
$table->setContent($filltable);

// echo the whole HTML
echo $table->render();
   


?><?php