<?php

/***********************************************
* CONTENIDO MODUL - OUTPUT
*
* Modulname            :     Kommentarmodul, beruht auf comments_sd
* Original Author(s)   :     www.Seamless-Design.de Markus Huebner
* Original Copyright   :     www.Seamless-Design.de Markus Huebner
* Originally Created   :     11.09.2011
* Adapted for 4.9 by   :     www.tone2tone.com, Viktor Lehmann
* modified             :     2013-09-05
* adapted              :     new sorting routine, new comment array, smarty template system, new input possibilities and more!
************************************************/

// initiziale additional table here, easier for future updates
$cfg['tab']['commentsmod'] = $cfg['sql']['sqlprefix']."_commentsmod";

// Prepare module info. Needed later to check if defined default smarty template is a real file 
$mod = new cApiModule($cCurrentModule);
$tplpath = $cfgClient[$client]["path"]["frontend"]."data/modules/".$mod->get("alias")."/template/";

// use smarty template to output module
$tpl = cSmartyFrontend::getInstance();

// values coming from input area
$searchstring           = array();
$enable                 = ( 'CMS_VALUE[10]' == "true" ) ? true : false ;
$pagination_perpage     = ( 'CMS_VALUE[11]' == 0 ) ? 10000 : 'CMS_VALUE[11]'; // amount of mainlevel entries per page, 0 = endless
$enable_br              = ( 'CMS_VALUE[12]' == "true" ) ? true : false ; // show or hide <br/> within comment text
$display_countchas      = ( 'CMS_VALUE[14]' > 0 ) ? true : false ;
$amount_countchas_total = ( 'CMS_VALUE[14]' < 1 || 'CMS_VALUE[14]' > 8 ) ? 6 : 'CMS_VALUE[14]'; // how many countchas should be displayed? 0 turn into default 6
$standard_onlinestatus  = ( 'CMS_VALUE[16]' == 1 ) ? 1 : 0 ; // 1: comment is immediately online after posting or 0: you have to set it online
$success_msg            = ( 'CMS_VALUE[16]' == 1 ) ? mi18n("confirmation_immediately_online") : mi18n("confirmation");
$maximum_comment_level  = ( 'CMS_VALUE[17]' > 0 ) ? 'CMS_VALUE[17]' : 0 ; // 0: no answer level. Goes up to 6 
$emailconfig            = "CMS_VALUE[20]";
$sTpl                   = "CMS_VALUE[100]";

// process some of the input values
$emails_in_array        = explode(",",$emailconfig); // email-adress(es) for email-alert. If empty, no mails will sent, see $mail_alert
$mail_alert             = ( !empty($emails_in_array) ) ? true : false ;
if ( 'CMS_VALUE[13]' == "true" ) $searchstring[] = "idart='".$idart."' AND " ; // only show comments posted on this idart or ALL posts
if ( 'CMS_VALUE[18]' == "false" ) $searchstring[] = "idlang='".$lang."' AND " ; // only show comments posted in actual language
$searchcondition        = ( !empty($searchstring) ) ? " WHERE ".substr( implode("", $searchstring ), 0, -4 ) : "";
debugger("Search string", $searchcondition);


// in case you need it, create your own section here to set your values manually, e.g.
/*
$enable                 = true ;
$pagination_perpage     = 5; 
$enable_br              = true ;
$emails_in_array        = array( "0"=>"mail@mail1.com", "1"=>"mail@mail2.com")
$searchcondition        = " WHERE idart='x' AND idlang='x' ";
...

*/

// configure more variables. Tweak debug here
$debug                  = false; // true or false. if you want to see several hints how this modul works, set it to true - have fun... ;O)

$path_countcha_1        = "images/countcha_01.jpg"; // path to first symbol
$path_countcha_2        = "images/countcha_02.jpg"; // path to second symbol
$main_url               = $cfgClient[$client]["path"]["htmlpath"]."front_content.php?idart=".$idart; //needed for correct link in email-alert and link in comment-box
$maincommentlink        = "front_content.php?idart=".$idart."&show_form=true";
$reload_url             = "../contenido/external/backendedit/front_content.php?idcat=$idcat&idart=$idart&lang=$lang&client=$client&contenido=$contenido";	

// process form input data
$commentname    = cleanup($_POST["commentname"]);
$commentemail   = cleanup($_POST[commentemail]);
$commentwebsite = cleanup($_POST[commentwebsite]);
$commentwebsite = str_replace("https://","",$commentwebsite);
$commentwebsite = str_replace("http://","",$commentwebsite);
$commenttext    = cleanup($_POST[commenttext]);
$amount         = cleanup($_POST[amount]);
$countcha       = cleanup($_POST[countcha]);
$show_form      = $_GET[show_form]; 
$parent_id      = cleanup($_GET[parent_id]);
$level          = cleanup($_GET[level]);
$timestamp      = time();
$date           = date("Y.m.d",$timestamp);
$time           = date("H:i:s",$timestamp);
//$lang           = 1;

debugger("Frontend Input Field Entries", array("submit"=>$submit, "commentname"=>$commentname, "commentemail"=>$commentemail, "commentwebsite"=>$commentwebsite, "commenttext"=>$commenttext, "date"=>$date, "time"=>$time, "lang"=>$lang, "idart"=>$idart) );
				  
/****** begin backend functions ******/

if ( $contenido ) {
	
	$change_id_select    = $_POST[change_id_select];
	$change_name         = cleanup($_POST[change_name]);  if ( $change_name == "" )  $change_name  = "-";
	$change_email        = cleanup($_POST[change_email]); if ( $change_email == "" ) $change_email = "-";
	$change_www          = cleanup($_POST[change_www]);   if ( $change_www == "" )   $change_www   = "-";
	$change_text         = cleanup($_POST[change_text]);  if ( $change_text == "" )  $change_text  = "-";
	$toggle_id           = cleanup($_GET[toggle_id]);
	$toggle_onlinestatus = cleanup($_GET[onlinestatus]);
	$erase               = cleanup($_GET[erase]);
	
	if ( $toggle_id != "" AND $toggle_onlinestatus!="" ) {
		$toggle = "UPDATE ".$cfg['tab']['commentsmod']." Set online = $toggle_onlinestatus WHERE id = $toggle_id";
		$db->query($toggle);
	}
	if ( $erase == "1" ) {
		$erase = "DELETE from ".$cfg['tab']['commentsmod']." WHERE id = $toggle_id";
		$db->query($erase);
	}
	
	debugger( "DB change values", array("toggle_id"=>$toggle_id, "online-status"=>$toggle_onlinestatus,"erase"=>$erase) );

    $query = "SELECT id FROM ".$cfg['tab']['commentsmod']." $searchcondition ORDER by id ASC";
	$result = cRegistry::getDb();
    $result->query($query);
    
	$selectOptions = array();
    $selectOptions[] = "?";
		
	while ( $result->nextRecord() ) {
		$selectOptions[] = $result->f("id");	
	}
	
	if ( $change_id_select == "?" ) {
		$foundbackenderror = mi18n("please_select_a_change_id");
	}
	else if ( $change_id_select != "" ) 	{
		debugger( "Backend comment change values", array("change_id_select"=>$change_id_select, "change_name"=>$change_name,"change_email"=>$change_email,"change_www"=>$change_www,"change_text"=>$change_text) );	
		if($change_name  != "-")  $db->query("UPDATE ".$cfg['tab']['commentsmod']." SET name='$change_name' WHERE id='$change_id_select'");
		if($change_email != "-")  $db->query("UPDATE ".$cfg['tab']['commentsmod']." SET email='$change_email' WHERE id='$change_id_select'");
		if($change_www   != "-")  $db->query("UPDATE ".$cfg['tab']['commentsmod']." SET website='$change_www' WHERE id='$change_id_select'");
		if($change_text  != "-")  $db->query("UPDATE ".$cfg['tab']['commentsmod']." SET text='$change_text' WHERE id='$change_id_select'");
	}
}

/****** end backend functions ******/



/****** check frontend form input ******/ 

if ( $submit != "" ) {
	
	$founderror = array();
	if ( $commentname == "" ) $founderror[] = mi18n("errormessage_commentname");
	if ( $commentemail == "" || ( $commentemail != "" && !preg_match("/^[\w-]+((\.|\+)[\w-]+)*@([a-z0-9-]+(\.[a-z0-9-]+)*?\.[a-z]{2,6}|(\d{1,3}\.){3}\d{1,3})(:\d{4})?$/i", $commentemail) ) )   $founderror[] = mi18n("errormessage_commentemail");
	//  if($commentwebsite != "" && !preg_match("/[w.0-9]{0,4}[a-zA-Z0-9.-]{2,40}[.][a-zA-Z]{2,7}/", $commentwebsite) $founderror[] = mi18n("errormessage_commentwebsite");
	if( $commenttext == "" ) $founderror[] = mi18n("errormessage_commenttext");
	if ( $display_countchas && $amount != $countcha ) $founderror[] = mi18n("errormessage_countchas");
	
	$insert_data = ( !empty($founderror) ) ? false : true ;
	
	if ( $insert_data ) {
		
		/****** save comment ******/
		
		$insert="INSERT INTO ".$cfg['tab']['commentsmod']." (idart, idlang, name, email, website, text, parent_id, level, date, time, online) VALUES ('$idart', '$lang', '$commentname', '$commentemail', '$commentwebsite', '$commenttext', '$parent_id', '$level', '$date', '$time', '$standard_onlinestatus')";
		$insert = $db->query($insert);
		if ( $insert ) debugger( "Insert procedure", "insert: success" ); else debugger( "Insert procedure", "insert: failure" ); 
		
		/****** send email(s) ******/
		
		if ( $mail_alert )
		{
			$mail_header      = mi18n("email_header");
			$from             = "From: Contenido Gaestebuch <info@contenido-comments.de>\n";
			$from            .= "Reply-To: info@contenido-comments.de\n";
			$from            .= "Content-Type: text/html\n";
			$message          = mi18n("email_message_new_comment_for").' <a href="'.$main_url .'" target="_blank">'.$main_url .'</a>';
			// send eMail
			
			foreach ( $emails_in_array as $mailto )
			{
				mail(utf8_decode($mailto), utf8_decode($mail_header), utf8_decode($message), utf8_decode($from));
			}
		}
		
	}	
	
}

/****** prepare new countchas AFTER processing form ******/ 

$i=0;
$amount = rand(1,$amount_countchas_total); // amount of symbols to count
$amount_wrong_countchas = $amount_countchas_total - $amount;
$countchaCollection = array();

while ($i<$amount_wrong_countchas) {
	$countchaCollection[]=$path_countcha_2;
	$i=$i+1;
}
while ($i<$amount_countchas_total) {
	$countchaCollection[]=$path_countcha_1;
	$i=$i+1;
}


/****** begin collecting and processing comments ******/

// only one query necessary. Frontendtree (showing ONLINE comments only) will be a changed version of Backendtree (query, showing ALL entries, online and offline)
$query = "SELECT *, if(level>0, id,0) AS sublevelsortierung FROM ".$cfg['tab']['commentsmod']." $searchcondition ORDER by sublevelsortierung ASC, id DESC";

$result = cRegistry::getDb();
$result->query($query);

// create proper array from query
while ( $result->nextRecord() ) { $cBackendTree[] = $result->toArray(); }
debugger( "Complete Comment Tree directly from database, unsorted", $cBackendTree );

$cBackendTree  = parentChildSort_r('id','parent_id',$cBackendTree);
$cFrontendTree = $cBackendTree ;  // split both arrays and deal with them separately from here on


// add additional values regarding children (if existing, and if so, how many)
foreach ($cBackendTree as $key => &$value) {
	// delete this from cFrontendtree immediately, if not online, makes life easier later
	if ( $value["online"] == "0" ) unset($cFrontendTree[$key]);
	// also delete unwanted levels from cFrontendtree
	if ( $value["level"] > $maximum_comment_level  ) unset($cFrontendTree[$key]);
	if ( $value["level"] == "0" ) { $keepkeyoflevel0 = $key; $cBackendParents[] = $key ; }
	if ( $value["level"] != "0" ) $cBackendTree[$keepkeyoflevel0]["numChild"] ++ ;
	if ( $value["id"] == $cBackendTree[$key+1]["parent_id"] ) { $cBackendTree[$key]["hasChild"] = "true" ; }
	$cBackendTree[$key]["level"]++;
	if ( $enable_br ) $cBackendTree[$key]["text"] = nl2br($cBackendTree[$key]["text"]);
	$d = explode("-", $cBackendTree[$key]["date"] );
	$cBackendTree[$key]["date"] = sprintf("%02d.%02d.%04d", $d[2], $d[1], $d[0]);
}

// do similar stuff for frontend, but re-index before
$cFrontendTree = array_values($cFrontendTree);

foreach ($cFrontendTree as $key => &$value) {
	if ( $value["level"] == "0" ) { $keepkeyoflevel0 = $key; $cFrontendParents[] = $key ; }
	if ( $value["level"] != "0" ) $cFrontendTree[$keepkeyoflevel0]["numChild"] ++ ;
	if ( $value["id"] == $cFrontendTree[$key+1]["parent_id"] ) { $cFrontendTree[$key]["hasChild"] = "true" ; }
	$cFrontendTree[$key]["level"]++;
	if ( $enable_br ) $cFrontendTree[$key]["text"] = nl2br($cFrontendTree[$key]["text"]);
	$d = explode("-", $cFrontendTree[$key]["date"] );
	$cFrontendTree[$key]["date"] = sprintf("%02d.%02d.%04d", $d[2], $d[1], $d[0]);		
}

debugger( "Backend Comment Tree, processed, complety", $cBackendTree );
debugger( "Frontend Comment Tree, processed, with all valid entries", $cFrontendTree );

// time to decide which tree to use for display and further count
if ( $contenido ) {
	$commentTree = $cBackendTree; 
	$commentParents = $cBackendParents;
} else {
	$commentTree = $cFrontendTree;
	$commentParents = $cFrontendParents;
}     

/******  building the pagination ******/
// to do this, we need the parents array we created especially for this occasion

$lastparentid         = count($commentParents)-1;
$lastcommentid        = count($commentTree);

$numbermainentries    = count($commentParents);
$numberofpages        = ceil( $numbermainentries/$pagination_perpage );
$actualpage           = ( !isset($_GET[pagination]) || $_GET[pagination] == "" || $_GET[pagination] <= 0  || $_GET[pagination] > $numberofpages ) ? 1 : $_GET[pagination];

$startentry           = ($actualpage-1) * $pagination_perpage;
$endentry             = $startentry + $pagination_perpage;

$startentryid         = $commentParents[$startentry];
$endentryid           = ( $actualpage == $numberofpages ) ? $lastcommentid : $commentParents[$endentry];
$numberofshownentries = ( $endentryid == $startentryid) ? 1 : $endentryid - $startentryid ;
debugger( "Pagination Settings for this Page", array( "startentryid"=>$startentryid, "endentryid"=>$endentryid, "number of shown entries"=>$numberofshownentries) );

// delete unwanted entries from frontend tree
if ( !$contenido )  $commentTree = array_slice ( $commentTree, $startentryid, $numberofshownentries , true) ;
debugger( "Sliced Frontend Comment Tree for this page (pagination)", $commentTree );

// build pagination array
$pagination = array();
for ( $i=1; $i <= $numberofpages; $i++ ) {		
	$pagination[$i]["class"] = ( $i == $actualpage ) ? "actualpage" : "";
	$pagination[$i]["page"]  = $i;
}	

/****** end processing comments ******/


// true-false values first
$tpl->assign('confirmation', $success_msg);
$tpl->assign('insert_data', $insert_data);
$tpl->assign('show_form', $show_form);
$tpl->assign('backend', $contenido);
$tpl->assign('enable', $enable);

// then the arrays
$tpl->assign('pagination', $pagination);
$tpl->assign('commentTree', $commentTree);
$tpl->assign('selectOptions', $selectOptions);
$tpl->assign('countchaCollection', $countchaCollection);

// then plain values
$tpl->assign('thisidart', $idart );
$tpl->assign('main_url', $main_url );
$tpl->assign('reload_url', $reload_url );
$tpl->assign('txtcommentsamount', $numbermainentries );
$tpl->assign('maincommentlink', $maincommentlink);
$tpl->assign('post_a_comment', mi18n("post_a_comment"));

$tpl->assign('value_change_name', $change_name);
$tpl->assign('value_change_email', $change_email);
$tpl->assign('value_change_www', $change_www);
$tpl->assign('value_change_text', $change_text);
$tpl->assign('button_update', mi18n("button_update") );

$tpl->assign('change_comment_headline', mi18n("change_comment_headline"));
$tpl->assign('change_comment_info', mi18n("change_comment_info"));
$tpl->assign('label_textarea', mi18n("label_textarea"));
$tpl->assign('change_comment_warning', mi18n("change_comment_warning"));

$tpl->assign('text_showanswers', mi18n("text_showanswers") );
$tpl->assign('text_hideanswers', mi18n("text_hideanswers") );
$tpl->assign('maximum_comment_level', $maximum_comment_level );
$tpl->assign('comments_disabled', mi18n("comments_disabled"));
$tpl->assign('no_comments_yet', mi18n("no_comments_yet"));
$tpl->assign('amount_of_comments_yet', mi18n("amount_of_comments_yet"));
$tpl->assign('answer_comment', mi18n("answer_comment"));
$tpl->assign('headline', mi18n("headline_form"));
$tpl->assign('founderror', $founderror);
$tpl->assign('foundbackenderror', $foundbackenderror);
$tpl->assign('name', mi18n("name"));
$tpl->assign('email', mi18n("email"));
$tpl->assign('website', mi18n("website"));
$tpl->assign('text', mi18n("text"));
$tpl->assign('how_many_countchas', mi18n("how_many_countchas"));
$tpl->assign('title_right_countcha', mi18n("title_right_countcha"));
$tpl->assign('how_many_countchas_hint_spam', mi18n("how_many_countchas_hint_spam"));
$tpl->assign('how_many_countchas_input', mi18n("how_many_countchas_input"));
$tpl->assign('countchas', $countchas);
$tpl->assign('title_right_countcha_input', mi18n("title_right_countcha_input"));
$tpl->assign('amount', $amount);
$tpl->assign('button_text', mi18n("button_text"));

if ( $enable || $contenido || $insert_data ) {
	
	if ( file_exists($tplpath.$sTpl) ) {
		
		$tpl->display($tplpath.$sTpl);
		
	} else {
		
		print mi18n("no_template_found");
		
	}
	
}
/************ functions *****************/

// function to sort all main entries DESC, but their children ASC, in the right order
function parentChildSort_r($idField, $parentField, $els, $parentID = 0, &$result = array(), &$depth = 0){
	foreach ($els as $key => $value):
	if ($value[$parentField] == $parentID){
		// neu: im 
		$value['depth'] = $depth;
		array_push($result, $value);
		unset($els[$key]);
		$oldParent = $parentID; 
		$parentID = $value[$idField];
		$depth++;
		parentChildSort_r($idField,$parentField, $els, $parentID, $result, $depth);
		$parentID = $oldParent;
		$depth--;
	}
	endforeach;
	return $result;
}

function cleanup( $toclean ) {
	$toclean = strip_tags ($toclean);
	$toclean = htmlspecialchars ($toclean);
	return $toclean;
}

function debugger( $debugheader, $debuginfo ) {
	
	global $debug;
	
	if ( $debug ) {		
		if ( is_array($debuginfo) ) {
			print '<pre><strong>'. $debugheader.'</strong><br>'; print_r($debuginfo); print '</pre>';
		} else {
			print '<p><strong>'. $debugheader.'</strong><br>'.$debuginfo.'</p>';
		}		
	}
}

?>